#******************************************************
# Loads Camera Data from a CSV file
# 
# - loadcameradata.py
# - By Mark Caldwell
# - Version 0.2
# - 18th May 2006
# - Copyright Mark Caldwell 2006
# - Tested with Vue 5 Infinite 5.09 and Vue 6 Infinite Pre Release
#
# How to use in 3 easy steps
#
# 1. Download this file onto your computer
#
# 2. Change Path to Saved File if required and camera to be edited
#
# 3. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
# 
#******************************************************

#-------------------------------------------------------------------
# Change if different on your computer
#-------------------------------------------------------------------

#Filename to Load Data From - Change if different on your computer
filename="C:\Program Files\e-on software\Vue 5 Infinite\Python\Scripts\impworks\utils\camera.csv"

# Animate a current camera or make a new camera.Set to 0 to create a new camera or the index of a camera in the scene 
cam_selection_method=0

#----------------------------------------------
# End of Changeable Parts
#----------------------------------------------

frames=[]

#----------------------------------------------
# Select or create the Camera
#----------------------------------------------

if cam_selection_method==0:
    cam=StoreCamera  ()
else:
    SelectByType(VuePython.VUEBasicObject.VOT_Camera)
    cam = GetSelectedObjectByIndex(0)

SelectByType(VuePython.VUEBasicObject.VOT_Camera)
cam = GetSelectedObjectByIndex(0)

#----------------------------------------------
# Read Camera Data in from CSV file
#----------------------------------------------

file=open(filename,'r')
      
while 1:
    line = file.readline()
    if not(line):
        break
            
    b=line.split(',')
    frames.append([float(b[0]),float(b[1]),float(b[2]),float(b[3]),float(b[4]),float(b[5]),float(b[6])])

file.close()

#----------------------------------------------
# Apply animation
#----------------------------------------------

for data in frames:
    SetCurrentFrame (data[0])
    cam.SetPosition(data[1],data[2],data[3])
    cam.SetRotationAngles(data[4],data[5],data[6],true)
    
#----------------------------------------------
# End of Script
#----------------------------------------------    
   

    

