#******************************************************
# Save Camera Data to a CSV file
# 
# - savecameradata.py
# - By Mark Caldwell
# - Version 0.1
# - 12th May 2006
# - Copyright Mark Caldwell 2006
# - Tested with Vue 5 Infinite 5.09 and Vue 6 Infinite Pre Release
#
# How to use in 4 easy steps
#
# 1. Download this file onto your computer
#
# 2. Change Path to Saved File if required
#
# 3. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
#
# 4. Camera path and rotation are now stored in the CSV
#    File and can be loaded using loadcameradata.csv
# 
#******************************************************

#------------------------------------------------------------------
# Filename to Load Data From - Change if different on your computer
#------------------------------------------------------------------

filename="C:\Program Files\e-on software\Vue 5 Infinite\Python\Scripts\impworks\utils\camera.csv"

#----------------------------------------------
# Internal Variables Set Up: Don't alter these
#----------------------------------------------

end=0
frames=[]
currentframe=0
oldframe=currentframe+1

#----------------------------------------------
# Find the camera
#----------------------------------------------

SelectByType(VuePython.VUEBasicObject.VOT_Camera)
cam = GetSelectedObjectByIndex(0)

#----------------------------------------------
# Find the first key frame if it comes before frame 0
#----------------------------------------------  

SetCurrentFrame(currentframe)

while end==0:
    PreviousKeyFrame ()
    currentframe=CurrentFrame ()
    if currentframe<oldframe:
        oldframe=currentframe
    else:
        end=1

#----------------------------------------------
# Step through key frames and read camera info
#----------------------------------------------  
        
end=0
oldframe=currentframe-2
SetCurrentFrame(currentframe-1)

while end==0:
    NextKeyFrame  ()
    currentframe=CurrentFrame ()
    if currentframe>oldframe:
        oldframe=currentframe
        pos=cam.Position()
        rot=cam.GetRotationAngles()
        frames.append([currentframe,pos[0],pos[1],pos[2],rot[0],rot[1],rot[2]])
    else:
        end=1


#----------------------------------------------
# Write out camera data to file
#----------------------------------------------  

output=open (filename,'w')
for f in frames:
    line=str(f[0])+','+str(f[1])+','+str(float(f[2]))+','+str(float(f[3]))+','+str(float(f[4]))+','+str(float(f[5]))+','+str(float(f[6]))+'\n'
    print line
    output.write(line)
output.close()

#----------------------------------------------
# End of Script
#----------------------------------------------    
   

    

